def get_dashboard_hosts
  hosts.select { |h| h['roles'].include? 'dashboard' }
end

def build_rake_cmd_string(host, cmd)
  rake_path = host.is_pe? ? "/opt/puppet/bin/rake" : "rake"
  rakefile_path = host.is_pe? ? "/opt/puppet/share/puppet-dashboard/Rakefile" : "/usr/share/puppet-dashboard/Rakefile"
  "RAILS_ENV=production #{rake_path} -f #{rakefile_path} #{cmd}"
end

def run_rake_task_raw(host, cmd)
  on(host, build_rake_cmd_string(host, cmd))
end

def run_rake_task(host, cmd)
  run_rake_task_raw(host, cmd).stdout.split("\n")
end

