require "#{File.dirname(__FILE__)}/../lib/spec_helper.rb"

describe 'The Dashboard' do

  before :all do
    visit_dashboard

    # wait for nodes to load
    session.should have_css("#content", :visible => true)
  end

  after :all do
    logout
  end

  describe 'class management' do

    class_name = 'test::class01'

    before :each do
      create_class(class_name)
    end

    it 'should add and remove a class' do
      should_have_class(class_name)
      remove_class(class_name)
      should_not_have_class(class_name)
    end

    it 'should rename a class' do
      new_class_name = 'test::class01x'
      select_class(class_name)
      session.find('#main').click_link('Edit')
      session.fill_in('node_class_name', :with => "#{new_class_name}")
      session.find('#main').click_button('Update')
      should_have_class(new_class_name)
      remove_class(new_class_name)
      should_not_have_class(new_class_name)
    end
  end

end
