var UNRESPONSIVE = '#818285';
var FAILED       = '#d93129';
var PENDING      = '#efa92d';
var CHANGED      = '#78b7d2';
var UNCHANGED    = '#78c145';
var ALL          = '#000';

jQuery(document).ready(function(J) {
  J(":input[placeholder]").placeholder();
  J.ajaxSetup({ 
    'beforeSend': function(xhr) {xhr.setRequestHeader("Accept", "text/html")}
  });

  J('table.main .status img[title]').tipsy({gravity: 's'});
  
  J('#main').tooltip();

  J('.typing_filter').each( function(index) {
    var name = J(this).attr("data-varname");
    J(this).append("<input type='hidden' name='" + name + "' id='" + name + "' value='{}'/>");
  });

  J('.typing_filter_input').on('click keyup paste cut input', function(e) {
    var filter = this.value.toLowerCase();
    var found = 0;
    J(this).parents('.typing_filter').find('.typing_filter_content .typing_filter_item_enabled > .typing_filter_item, .typing_filter_content .typing_filter_item_disabled > .typing_filter_item').each(function(index) {
      if(J(this).find('.typing_filter_item_value').toArray()[0].textContent.toLowerCase().indexOf(filter) != -1) {
        J(this).parents('.typing_filter_item_wrapper_hidden').show()
          .removeClass('typing_filter_item_wrapper_hidden')
          .addClass('typing_filter_item_wrapper');
        found++;
      }
      else {
        J(this).parents('.typing_filter_item_wrapper').hide()
          .removeClass('typing_filter_item_wrapper')
          .addClass('typing_filter_item_wrapper_hidden');
      }

      J(this).parents('.typing_filter_content').find('.typing_filter_item_wrapper').each(function(index) {
        J(this).removeClass('odd even').addClass(index % 2 == 0 ? 'odd' : 'even'); // 0th item is actually the 1st item :-)
      });
    });

    J(this).parents('.typing_filter').find('.info').each(function(index) {
      var singular = J(this).attr("data-singular");
      var plural = J(this).attr("data-plural");
      this.textContent = found + ' ' + (found == 1 ? singular : plural) + ' found';
    });
  })
  
  J('.typing_filter').on('click', '.typing_filter_item', function(e) {
    J(this).find('input:checkbox').click();
  });

  J('.typing_filter').on('click', '.typing_filter_item > input:checkbox', function(e) {
    e.stopPropagation();
    
    var checked = this.checked;

    J(this).next().find('.typing_filter_item_value').each( function(index) {
      var item_value = this.textContent.trim();
      var item_desc = null;

      J(this).parents('.typing_filter_item_wrapper').find('.typing_filter_item_custom_desc').each( function(index) {
        item_desc = this.textContent;
      });

      J(this).parents('.typing_filter').each( function(index) {
        J(this).find("input[name='" + J(this).attr("data-varname") + "']").each( function(index) {
          var selected_items = J.parseJSON(this.value);
          
          if(checked) {
            selected_items[item_value] = item_desc;
          }
          else {
            delete selected_items[item_value];
          }
          
          this.value = JSON.stringify(selected_items);
        });
      });
    });
  });

  J('.typing_filter_custom_input').on('click keyup paste cut input', function(e) {
    var input = this;

    setTimeout(function() {
      var custom_item_value = input.value.trim();
      var enabled = false;
      var jinput = J(input);
      var duplicate_message = '';

      if (custom_item_value != '') {
        enabled = true;

        jinput.parents('.typing_filter').each( function(index) {
        
          J(this).find('.typing_filter_item_value').each( function(index) {
            if (this.textContent.trim() == custom_item_value) {
              enabled = false;
              duplicate_message = J(this).parents('.typing_filter_container').attr("data-duplicate-message");
              return false;
            }
          });
        });
      }

      if (enabled) {
        jinput.parent().find('.typing_filter_add_custom_button_enabled').show();
        jinput.parent().find('.typing_filter_add_custom_button_disabled').hide();
        jinput.parent().find('.typing_filter_duplicate_message').html('');
      }
      else {
        jinput.parent().find('.typing_filter_add_custom_button_enabled').hide();
        jinput.parent().find('.typing_filter_add_custom_button_disabled').show();
        jinput.parent().find('.typing_filter_duplicate_message').html(duplicate_message);
      }
    }, 0);
  });

  J('.typing_filter_custom_input, .typing_filter_custom_input_description').keypress(function(e) {
    if(e.keyCode == 13) {
      e.preventDefault();
      e.stopImmediatePropagation();
      J(this).parents('.typing_filter').find('.typing_filter_add_custom_button').click();
    }
  });

  J('.typing_filter_content_custom').hide();

  J('.typing_filter .typing_filter_add_custom_button').click( function(e) {
    J(this).parents('.typing_filter').find('.typing_filter_custom_input').each( function(e) {
      var custom_item_value = this.value.trim();
      var custom_item_input_description = null;
      var value_applied = false;

      if (custom_item_value == '') {
        return;
      }

      J(this).parents('.typing_filter').each( function(index) {
        var typing_filter = J(this);

        var exists = false;
        
        typing_filter.find('.typing_filter_item_value').each( function(index) {
          if (this.textContent.trim() == custom_item_value) {
            exists = true;
          }
        });

        if (exists) {
          return;
        }
        
        var custom_item_description = '';

        typing_filter.find('.typing_filter_custom_input_description').each( function(index) {
          custom_item_input_description = this;
          custom_item_description = this.value.trim();
        });

        var new_item_html = J(this).find('.typing_filter_item_custom').html();
        var parent = typing_filter.find('.typing_filter_item_custom').parent();
        parent.append(new_item_html);
        parent.find('.typing_filter_item_wrapper:last').attr("data-item-value", custom_item_value);
        parent.find('.typing_filter_item_value:last').each( function(index) {
          this.textContent = custom_item_value;
        });
        parent.find('.typing_filter_item_custom_desc:last').each( function(index) {
          this.textContent = custom_item_description;
        });
        parent.find('.typing_filter_item > input:checkbox:last').click();
        parent.find('.typing_filter_item_value:last').attr("title", custom_item_value);
        J('.typing_filter_content_custom').show();

        value_applied = true;
      });

      if (value_applied) {
        this.value = '';
        custom_item_input_description.value = '';
        J(this).click();
        this.focus();
      }
    });
  });

  J('.disclosure_control_label').each( function(index) {
    this.textContent = "show more";
    J(this).parents('.disclosure_control').parent().find('.disclosure_content').hide();
  });

  J('.disclosure_control_label').click( function(e) {
    var control_label = this;
    var control = J(this).parents('.disclosure_control');
    var control_parent = J(control).parent(); 
    var content = control_parent.find('.disclosure_content'); 
    var snippet = control_parent.find('.disclosure_snippet'); 
    var lazy_url = content.attr("data-lazy-url");

    if (lazy_url != null && content.css('display') == 'none') {
      content.find(content.attr("data-container-selector")).html("<i>Loading...</i>");
    }

    if(content.css('display') == 'none') {
      J(snippet).hide();
    }

    content.slideToggle(0, function(e) {
      if(content.css('display') == 'none') {
        control_label.textContent = "show more";
        J(snippet).show();
      }
      else {
        control_label.textContent = "show less";

        if (lazy_url != null) {
          content.attr("data-lazy-url", null);

          var request = J.ajax({
            url: lazy_url,
            dataType: "json"
          });
 
          request.done(function(response) {
            content.find(content.attr("data-container-selector")).html(response.full);
          });
 
          request.fail(function(jqXHR, textStatus) {
            if(jqXHR.status == 401) {
              window.location.reload();
              return;
            }
            content.find(content.attr("data-container-selector")).html("Oops, something went wrong and the documentation could not be retrieved. Try again later.");
            content.attr("data-lazy-url", lazy_url);
          });
        }
      }
    });
  });

  J('.typing_filter').on('click', '.typing_filter_item_custom_remove_label', function(e) {
    J(this).parents('.typing_filter_item_wrapper').each( function(index) {
      J(this).find('input:checkbox').each( function(index) {
        if(this.checked) {
          J(this).click();
        }
        
        return false;
      });
      J(this).parents('.typing_filter_content_custom').each (function(index) {
        // if the line to be removed is the last one then hide the whole table;
        // remember that there's still the hidden template so if there are 2 occurrences
        // then we're removing the last line
        if(J(this).find('.typing_filter_item_wrapper').length == 2) {
          J(this).hide();
        }
        return false;
      });
      J(this).remove();
      
      return false;
    });
  });

  J('.custom_input_key').on('click keyup paste cut input', function(e) {
    var input = this;

    setTimeout(function() {
      var custom_item_key = input.value.trim();
      var enabled = false;
      var jinput = J(input);

      if (custom_item_key) {
        enabled = true;

        if(class_parameter_exists(J, custom_item_key)) {
          enabled = false;
        }
      }

      if (enabled) {
        jinput.parent().find('.add_custom_button_enabled').show();
        jinput.parent().find('.add_custom_button_disabled').hide();
      }
      else {
        jinput.parent().find('.add_custom_button_enabled').hide();
        jinput.parent().find('.add_custom_button_disabled').show();
      }
    }, 0);
  });

  J('#class_param_form .add_custom_button_enabled').click( function(e) {
    var custom_param_key = J('.custom_input_key').first().val();
    var custom_param_value = J('.custom_input_value').first().val();
    var values_applied = false;

    if (!custom_param_key) {
      return;
    }

    var exists = false;

    J('#class_parameters_table td:nth-child(1)').each(function(index){
      if(J(this).text() == custom_param_key) {
        exists = true;
        return false;
      }
    });

    if(exists == true) {
      J('#custom_class_parameters_table td:nth-child(1)').each(function(index){
        if(J(this).text() == custom_param_key) {
          exists = true;
      	  return false;
        }
      });
    }
    
    var tbody = jQuery('#custom_class_parameters_table tbody');
    insert_custom_class_parameter_tr(tbody, custom_param_key, custom_param_value);
    jQuery('#custom_class_parameters_table_wrapper').show();
    
    values_applied = true;

    if (values_applied) {
      init_custom_class_inputs();
    }
  });
  
  J('button.drop, a.drop').click( function(e) {
    var self = J(this);
    var all_drops = self.parents('div').find('.dropdown');
    var drop = self.next('.dropdown');

    if (drop.is(':hidden')) {
      all_drops.hide();
      drop.show();
      drop.bind('click', function(e){e.stopPropagation()});
      J(document).one('click.hideDropdown', function() {drop.hide()});
    } else {
      all_drops.hide();
    };

    return false;
  })

  J('table.main th input#check_all').click( function() {
    self = J(this);
    self.parents('table').find('td input:checkbox').attr('checked', self.is(':checked'));
  });

  J('a.in-place').click(function() {
    J(this).parents('.header').hide().next('.in-place').show().find('input[type=text]').focus();
    return false;
  });

  J.fn.mapHtml = function() { return this.map(function(){return J(this).html()}).get(); }
  J.fn.mapHtmlInt = function() { return this.map(function(){return parseInt(J(this).html())}).get(); }
  J.fn.mapHtmlFloat = function() { return this.map(function(){return parseFloat(J(this).html())}).get(); }

  J("table.data.runtime").each(function(i){
    var id = "table_runtime"+i;
    J("<div id='"+id+"' style='height:150px; width: auto;'></div>").insertAfter(J(this));

    var label_data = J(this).find("tr.labels th").mapHtml();
    var runtime_data = J(this).find("tr.runtimes td").mapHtmlFloat();
    var format = "%" + (Math.max.apply(null, runtime_data) < 3 ? ".1f" : "d") + " s"; 

    J.jqplot(id, [runtime_data], {
      seriesColors: ["#009"],
      captureRightClick: false,
      seriesDefaults:{
        markerOptions: {
          show: false
        },
        pointLabels: {
          show: false
        }
      },
      axes: {
        xaxis: {
          renderer: J.jqplot.CategoryAxisRenderer,
          tickRenderer: J.jqplot.CanvasAxisTickRenderer,
          ticks: label_data,
          tickOptions: {
            angle: -30,
            fontSize: '9px',
            textColor: '#666'
          }
        },
        yaxis: {
          // Don't pad out the bottom of the data range.  By default,
          // axes scaled as if data extended 10% above and below the
          // actual range to prevent data points right on grid boundaries.
          // Don't want to do that here.
          padMin: 0,

          tickOptions: {
            formatString: format
          }
        }
      },
      grid: {
        background: '#fff',
        drawGridlines: false,
        borderWidth: 1,
        shadow: false
      },
      legend: {
        show: false,
      }      
    });

    J(this).hide();
  });



  J("table.data.status").each(function(i){
    var id = "table_status"+i;
    J("<div id='"+id+"' style='height: 150px; width: auto; margin-right: 100px;'></div>").insertAfter(J(this));

    var label_data = J(this).find("tr.labels th").mapHtml();
    var changed_data = J(this).find("tr.changed td").mapHtmlInt();
    var unchanged_data = J(this).find("tr.unchanged td").mapHtmlInt();
    var pending_data = J(this).find("tr.pending td").mapHtmlInt();
    var failed_data = J(this).find("tr.failed td").mapHtmlInt();

    var changed_data_label = J.map(changed_data, function(item, index){return item+" changed"});
    var unchanged_data_label = J.map(unchanged_data, function(item, index){return item+" unchanged"});
    var pending_data_label = J.map(pending_data, function(item, index){return item+" pending"});
    var failed_data_label = J.map(failed_data, function(item, index){return item+" failed"});

    J.jqplot(id, [changed_data, unchanged_data, pending_data, failed_data], {
      stackSeries: true,
      captureRightClick: false,
      seriesDefaults:{
        renderer:J.jqplot.BarRenderer,
        rendererOptions: {
          barMargin: 0,
          shadow: false,
          highlightMouseDown: true
        },
        pointLabels: {
          show: false
        }
      },
      series: [
        {
          label: 'Changed',
          color: CHANGED
        },
        {
          label: 'Unchanged',
          color: UNCHANGED
        },
        {
          label: 'Pending',
          color: PENDING
        },
        {
          label: 'Failed',
          color: FAILED
        }
      ],
      axes: {
        xaxis: {
          renderer: J.jqplot.CategoryAxisRenderer,
          tickRenderer: J.jqplot.CanvasAxisTickRenderer,
          ticks: label_data,
          tickOptions: {
            angle: -30,
            fontSize: '9px',
            textColor: '#666'
          }
        },
        yaxis: {
          // Don't pad out the data range.  By default,
          // axes scaled as if data extended 10% above and below the
          // actual range to prevent data points right on grid boundaries.
          // Don't want to do that here.
          pad: 0,
          min: 0
        }
      },
      grid: {
        background: '#fff',
        drawGridlines: false,
        borderWidth: 0,
        shadow: false
      },
      legend: {
        show: true,
        location: 'ne',
        placement: 'outside'
      }      
    });

    J(this).hide();
  });
  init_expandable_list();

  J('.reports_show_action #report-tabs').show();
  J('.reports_show_action .panel').addClass('tabbed');
  J('.reports_show_action #report-tabs li').click(function() {
    panelID = this.id.replace(/-tab$/, '');
    J('.reports_show_action #report-tabs li').removeClass('active');
    J('.reports_show_action .panel').hide();
    J(this).addClass('active');
    J('#' + panelID).show();
  });
  J('.reports_show_action #report-tabs li:first').click();

  J('.pages_home_action #home-tabs').show();
  J('.pages_home_action .panel').addClass('tabbed');
  J('.pages_home_action #home-tabs li').click(function() {
    panelID = this.id.replace(/-tab$/, '');
    J('.pages_home_action #home-tabs li').removeClass('active');
    J('.pages_home_action .panel').hide();
    J(this).addClass('active');
    J('#' + panelID).show();
  });
  J('.pages_home_action #home-tabs li:first').click();

  // If there's a tab id in the location hash, click it!
  J(window.location.hash).click();

  init_sidebar_links();
  init_skiplink_target();
});

function class_parameter_exists(J, key) {
  
  var exists = false;
  
  J('#class_parameters_table td:nth-child(1)').each(function(index){
    if(J(this).text() == key) {
    exists = true;
    return false;
    }
  });
  
  if(exists == false) {
    J('#custom_class_parameters_table td:nth-child(1)').each(function(index){
      if(J(this).text() == key) {
        exists = true;
        return false;
      }
    });
  }
  
  return exists;
}

function init_expandable_list() {
  jQuery( '.expand-all' ).on( 'click', function() {
    jQuery('.expandable-link.collapsed-link').each(toggle_expandable_link);
    return false;
  });
  jQuery( '.collapse-all' ).on( 'click', function() {
    jQuery('.expandable-link').not('.collapsed-link').each(toggle_expandable_link);
    return false;
  });
  jQuery( '.expandable-link' ).on( 'click', function() {
    toggle_expandable_link.call(this);
    return false;
  });
}

function toggle_expandable_link() {
  expansionTime = 30; // ms
  jQuery(this).toggleClass('collapsed-link');
  jQuery(this.id.replace('expand', '#expandable'))
    .toggle('blind', {}, expansionTime);
  if (jQuery(this).hasClass('collapsed-link')) {
    if (jQuery('.expandable-link').not('.collapsed-link').size() == 0) {
      var old_text = jQuery('.collapse-all').text();
      jQuery('.collapse-all')
        .removeClass( 'collapse-all' )
        .addClass( 'expand-all' )
        .text( old_text.replace( 'collapse', 'expand' ));
    }
  } else {
    if (jQuery('.expandable-link.collapsed-link').size() == 0) {
      var old_text = jQuery('.expand-all').text();
      jQuery('.expand-all')
        .removeClass( 'expand-all' )
        .addClass( 'collapse-all' )
        .text( old_text.replace( 'expand', 'collapse' ));
    }
  }
}

function display_file_popup(url) {
    jQuery.colorbox({href: url, width: '80%', height: '80%', iframe: true});
}

function init_sidebar_links() {
  jQuery( '.node_summary .primary tr' ).each( function() {
    jQuery( this )
      .hover(
        function() {
          jQuery( this ).addClass( 'hover' );
        },
        function() {
          jQuery( this ).removeClass( 'hover' );
        }
      )
      .click( function() {
        var url = jQuery( this ).find( '.count a' ).attr( 'href' );
        document.location.href = url;
        return false;
      });
  });
}

function init_skiplink_target() {
  var is_webkit = navigator.userAgent.toLowerCase().indexOf('webkit') > -1;
  var is_opera = navigator.userAgent.toLowerCase().indexOf('opera') > -1;
  if(is_webkit || is_opera)
  {
    var target = document.getElementById('skiptarget');
    target.href="#skiptarget";
    target.innerText="Start of main content";
    target.setAttribute("tabindex" , "0");
    document.getElementById('skiplink').setAttribute("onclick" , "document.getElementById('skiptarget').focus();");
  }
}

function autosuggestResultFilter(class_id) {
	return function(results) { 
		var alreadyAssigned = jQuery(class_id).parent().find('.token-input-token-facebook p');
		var myresults = results;
		alreadyAssigned.each(function(i){
			myresults = myresults.filter(function(element,index,array){ 
				return alreadyAssigned[i].innerText != element.name;
			});
		});
		return myresults;
	};
};

function remove_entity_from_tr_and_input(current_object, input_id, id, additional_removal) {
  jQuery(current_object).parents('tr').remove();
  var ids = '';
  var ids_array = jQuery('#' + input_id).val().split(',');
  for(var i = 0; i < ids_array.length; i++) {
    if(ids_array[i] != id) {
      if(ids.length > 0) {
        ids = ids + ','
      }
      ids = ids + ids_array[i]
    }
  }
  jQuery('#' + input_id).val(ids);
  
  if(additional_removal) {
    additional_removal();
  }
}

function insert_custom_class_parameter_tr(tbody, custom_param_key, custom_param_value) {
  tbody.append(jQuery("<tr/>")
    .append(jQuery("<td/>").text(custom_param_key))
    .append(jQuery("<td/>")
      .append(jQuery("<input type='text'/>")
        .attr("placeholder", "add value")
        .attr("value", (typeof custom_param_value !== 'undefined') ? custom_param_value : "")
        .addClass("class_param_value")
      )
    )
    .append(jQuery("<td/>")
      .append(jQuery("<div/>")
        .addClass("param_action")
        .append(jQuery("<a/>")
          .attr("href", "#")
          .click(function() {
            remove_custom_parameter(this);
          })
          .text("Delete")
        )
      )
    )
  );
}

function remove_custom_parameter(current_object) {
  var parent_table = jQuery(current_object).parents('table');
  jQuery(current_object).parents('tr').remove();
  if(parent_table.find('tbody tr').size() == 0) {
    jQuery('#custom_class_parameters_table_wrapper').hide();  
  }
}

function init_custom_class_inputs() {
  jQuery('#custom_param_key').val('');
  jQuery('#custom_param_value').val('');
}

function remove_class_from_class_parameters_input_field(class_id, class_parameters_input_id) {
  var class_parms = JSON.parse(jQuery('#' + class_parameters_input_id).val());
  delete class_parms[class_id]; 
  jQuery('#' + class_parameters_input_id).val(JSON.stringify(class_parms));	
}

function enable_disable_element_according_to_table_rows(element_id, table_id) {
  if(jQuery("#" + table_id + " tr").length > 1) {
    jQuery("#" + element_id).show();
  }
  else {
    jQuery("#" + element_id).hide();
  }
}

function show_error_message(error_message) {
  jQuery('#error_messages').html("<div class='errors element'><b>ERROR:</b> " + error_message + "</div>");
  jQuery('#error_messages').show();
}

function hide_error_messages() {
  jQuery('#error_messages').hide();
  jQuery('#error_messages').html('');
}

function toggle_class_param(class_param) {
  if(class_param) {
    jQuery("#popupWrapper").appendTo("body").tooltip();
  }
  else {
    jQuery("#popupWrapper").appendTo("#class_param_form");
  }
}

function show_class_parameters(class_id, class_name, form_field_id, resource_type, resource_name) {

  var class_parms = JSON.parse(jQuery('#' + form_field_id).val());
  var this_class_parms = class_parms[class_id];
  jQuery.ajax({
    url: ('/node_classes/select_parameters/' + class_id + '.json'),
    dataType: 'json',
    beforeSend: function() {
      hide_error_messages();
    },
    success: function(data, textStatus, jqXHR) {
      jQuery('#class_parameters_table tbody tr').remove();
      
      var tbody = jQuery('#class_parameters_table tbody');
      var data_array = [];
      
      jQuery.each(data, function(key, value) {
        data_array.push([key, value]);
      });
      
      data_array.sort(function(a,b) {
        return a[0] > b[0] ? 1 : (a[0] < b[0] ? -1 : 0);
      });
      
      var show_reset_to_defaults_flag = false;
      
      jQuery.each(data_array, function(idx, item) {
        var default_flag = false;
        if(this_class_parms) {
          value = this_class_parms[item[0]];
          if((typeof value === 'undefined') || value.toString().length == 0) {
            default_flag = true;
          }
          else {
            show_reset_to_defaults_flag = true;
          }
        }
        else {
          default_flag = true;
        }

        tbody.append(jQuery("<tr/>")
          .append(jQuery("<td/>").text(item[0]))
          .append(jQuery("<td/>")
            .append(jQuery("<input type='text'/>")
              .attr("placeholder", item[1])
              .attr("title", "default: <b>" + jQuery("<div/>").text(item[1]).html() + "</b>")
              .addClass("class_param_value")
              .addClass(!default_flag && (typeof value !== 'undefined') ? "highlight" : "")
              .attr("value", (typeof value !== 'undefined') ? value : "")
            )
          )
          .append(jQuery("<td/>").css("display", "none").text(item[1]))
          .append(jQuery("<td/>")
            .append(jQuery("<div/>")
              .addClass("param_action")
                .append(jQuery("<a/>")
                  .attr("href", "#")
                  .addClass("reset_to_default")
                  .css("display",  default_flag ? "none" : "")
                  .click(function() {
                    reset_to_default(this);
                  })
                  .text("Reset to default")
                )
            )
          )
        );
      });
      
      if(data_array.length == 0) {
        jQuery('#class_parameters_table').hide();
        jQuery('#no_params_label').show();
      }
      else {
        jQuery('#class_parameters_table').show();
        jQuery('#no_params_label').hide();
      }
      
      if(show_reset_to_defaults_flag) {
        show_reset_to_defaults();
      }
      else {
        hide_reset_to_defaults();
      }

      jQuery('#custom_class_parameters_table tbody tr').remove();
      tbody = jQuery('#custom_class_parameters_table tbody');
      var custom_params = false;
      var this_class_parms_array = [];

      if(this_class_parms) {
        jQuery.each(this_class_parms, function(key, value) {
          this_class_parms_array.push([key, value]);
        });
        this_class_parms_array.sort(function(a,b) {
          return a[0] > b[0] ? 1 : (a[0] < b[0] ? -1 : 0);
        });
        jQuery.each(this_class_parms_array, function(idx, item) {
          if(!data[item[0]]) {
            insert_custom_class_parameter_tr(tbody, item[0], item[1]);
            custom_params = true;
          }    
        });
      }
      
      if(custom_params) {
        jQuery('#custom_class_parameters_table_wrapper').show();
      }
      else {
        jQuery('#custom_class_parameters_table_wrapper').hide();
      }

      var resource_type_label = resource_type.charAt(0).toUpperCase() + resource_type.substr(1);
      var class_name_label = class_name.charAt(0).toUpperCase() + class_name.substr(1);
      
      jQuery('#param_form_subtitle').html("<b>" + class_name_label + "</b> parameters");
      jQuery('#class_id').html(class_id);

      jQuery('#class_parameters_table input').on('click keyup paste cut input', function(){
        var input_val = jQuery(this).parents('tr').find('input').first().val();
        if(input_val.length == 0) {
         hide_reset_to_default(this);
          suppress_highlight(this);
        }
        else {
          show_reset_to_default(this);
          if(input_val) {
            highlight(this);
          }
          else {
            suppress_highlight(this);
          }
        }
      });

      init_custom_class_inputs();
      toggle_class_param(true);
    },
    error: function(jqXHR, textStatus, errorThrown) {
      show_error_message(errorThrown);
    }
  });
}

function show_reset_to_defaults() {
  jQuery('#reset_to_defaults').show();
}

function hide_reset_to_defaults() {
  jQuery('#reset_to_defaults').hide();
}

function show_reset_to_default(current_object) {
  jQuery(current_object).parents('tr').find('td:nth-child(4) a').show();
  show_reset_to_defaults();
}

function hide_reset_to_default(current_object) {
  jQuery(current_object).parents('tr').find('td:nth-child(4) a').hide();

  var show_reset_to_defaults_flag = false;
  jQuery('#class_parameters_table .reset_to_default').each(function(){
    if(jQuery(this).is(':visible')) {
      show_reset_to_defaults_flag = true;
      return false;
    }
  });
  
  if(!show_reset_to_defaults_flag) {
    hide_reset_to_defaults();
  }
}

function highlight(current_object) {
  jQuery(current_object).parents('tr').find('input').first().addClass('highlight');
}

function suppress_highlight(current_object) {
  jQuery(current_object).parents('tr').find('input').first().removeClass('highlight');
}

function reset_to_default(current_object) {
  jQuery(current_object).parents('tr').find('input').first().val('');
  hide_reset_to_default(current_object);
  suppress_highlight(current_object);
}

function reset_to_defaults() {
  jQuery('#class_parameters_table tbody tr td:nth-child(1)').each(function(){
    reset_to_default(jQuery(this));
  });
}

function save_class_parameters(class_id_id, form_field_id, table_id, custom_table_id) {
  var class_id = jQuery('#' + class_id_id).html();
  var class_parms = JSON.parse(jQuery('#' + form_field_id).val());
  var this_class_parms = {}
  this_class_parms = retrieve_params_from_table(this_class_parms, table_id);
  this_class_parms = retrieve_params_from_table(this_class_parms, custom_table_id);

  var custom_param_key = jQuery('#custom_param_key').val();
  var custom_param_value = jQuery('#custom_param_value').val();
  if(custom_param_key && !class_parameter_exists(jQuery, custom_param_key) && custom_param_value) {
  this_class_parms[custom_param_key] = custom_param_value;
  }

  class_parms[class_id] = this_class_parms;
  jQuery('#' + form_field_id).val(JSON.stringify(class_parms));
  toggle_class_param(false);
}

function retrieve_params_from_table(this_class_parms, table_id) {
  jQuery('#' + table_id + ' tbody tr').each(function (index) {
    var key;
    var value;
    jQuery(this).find('td').each(function (idx) {
      if(idx == 0) {
        key = jQuery(this).text()
      }
      else if(idx == 1) {
        value = jQuery(this).find('input').first().val();
      }
    });
  
    if(value) {
      this_class_parms[key] = value;
    }
  });
  return this_class_parms;
}

function show_class_conflicts(node_class_name, node_class_url, class_conflicts_json) {

  jQuery('#class_conflicts_table tbody tr').remove();

  jQuery('#node_class_link a').remove();
  jQuery('#node_class_link').append('<a href="' + node_class_url + '"></a>');
  jQuery('#node_class_link a').first().text(node_class_name);

  var json = jQuery.parseJSON(class_conflicts_json);
  
  var params = [];
  var values = [];
  var sources = [];

  jQuery.each(json, function(i, item_i) {
  
    var param = Object.keys(item_i)[0];
    var html = '<tr><td class="conflict_param" rowspan="' + item_i[param].length + '"><tt></tt></td>';
    params.push(param);
    var tr = true;
    
    jQuery.each(item_i[param], function(j, item_j) {
      var value = Object.keys(item_j)[0];
      if(!tr) {
        html = html + '<tr>';
      }
      html = html + '<td class="conflict_value" style="background-color: pink;"><tt></tt></td><td class="conflict_source"><tt>';
      values.push(value);
      var col = true;
      
      jQuery.each(item_j[value], function(k, item_k) {
        if(!col) {
          html = html + ', ';
        }
        html = html + '<a href="' + item_k['url'] + '"></a>';
        sources.push(item_k['name']);
        col = false;
      });
      
      html = html + '</tt></td></tr>';
      tr = false;
    });
    
    jQuery('#class_conflicts_table tbody').append(html);
  });

  jQuery('#class_conflicts_table tbody .conflict_param tt').each(function(i){
    this.textContent = params[i];
  });

  jQuery('#class_conflicts_table tbody .conflict_value tt').each(function(i){
    this.textContent = values[i];
  });

  jQuery('#class_conflicts_table tbody .conflict_source tt a').each(function(i){
    this.textContent = sources[i];
  });

  jQuery("#popupWrapper").appendTo("body");
}

function hide_class_conflicts() {
  jQuery("#popupWrapper").appendTo("#class_conflicts");
}
