begin
  require 'console_auth_middleware'

  ::ConsoleAuth.init


  PuppetDashboard::Application.config.session_store :active_record_store,
                         :key           => ::ConsoleAuth.get_config['authentication']['session_key'],
                         :secret        => ::ConsoleAuth.get_config['authentication']['session_secret'],
                         :expire_after  => ::ConsoleAuth.get_config['authentication']['session_timeout'] || 1200,
                         :secure        => true

  PuppetDashboard::Application.config.middleware.use Rack::ConsoleAuth::Authentication,
                        :cas_base_url   => ::ConsoleAuth.cas_base_url,
                        :service_url    => ::ConsoleAuth.get_config['authentication']['service_url'],
                        :validate_url   => ::ConsoleAuth.get_config['authentication']['validate_url'],
                        :session_dir    => './tmp/sessions',
                        :logger         => ::Logger.new(::ConsoleAuth.get_config['log']['client_file']),
                        :allow_unauthenticated_urls => ::ConsoleAuth.unauthenticated_restrictions

  PuppetDashboard::Application.config.middleware.use Rack::ConsoleAuth::Authorization

  PuppetDashboard::Application.config.middleware.use Rack::Csrf, :skip_if => lambda { |request|
    ConsoleAuth.skip_rack_csrf?(request)
  }

rescue LoadError => e
  Rails.logger.error "Problem loading console auth middleware: #{e}"
end
